﻿
''' <summary>
''' Realiza la tarea de la division
''' </summary>
Friend Class EslabonDivision
    Inherits EslabonCadenaConcreto

#Region "Miembros [MustOverride] de la clase base"

    ' la clave que identifica a este eslabón
    Public Overrides ReadOnly Property Key As String
        Get
            Return "División"
        End Get
    End Property

    Public Overrides Function ExecuteTarea(ByRef paramObjUnMensaje As MensajeVo) As RespuestaVo

        If String.Equals(paramObjUnMensaje.Key.ToUpper, Me.Key.ToUpper) Then
            ' Este eslabón es el que tiene que hacer el trabajo
            Return HacerLaTareaDelEslabon(paramObjUnMensaje)

        Else
            ' Pasar el problema al siguiente eslabón de la cadena
            Return Me.SiguienteEslabon.ExecuteTarea(paramObjUnMensaje)
        End If

    End Function
#End Region

    ''' <summary>
    ''' Función que hace el trabajo
    ''' </summary>
    ''' <param name="paramObjUnMensaje">El objeto [MensajeVo] que contiene los datos iniciales para hacer el trabajo</param>
    ''' <returns>Un objeto [RespuestaVo] que contiene la respuesta a la tarea encargada </returns>
    Private Function HacerLaTareaDelEslabon(ByRef paramObjUnMensaje As MensajeVo) As RespuestaVo

        Dim localObjResultado As New RespuestaVo
        localObjResultado.Resultado = paramObjUnMensaje.DatoUno / paramObjUnMensaje.DatoDos

        Return localObjResultado

    End Function


End Class
