﻿



''' <summary>
''' El ultimo eslabón de la cadena
''' </summary>
Friend Class Eslabon_Centinela
    Inherits EslabonCadenaConcreto

#Region "Miembros [MustOverride] de la clase base"

    ' la clave que identifica a este eslabón
    Public Overrides ReadOnly Property Key As String
        Get
            Return "NodoCentinela"
        End Get
    End Property

    '----------------------------------------
    ' la función que hace el trabajo. En este caso dispara una excepción
    ' también se podría devolver algún valor que a modo de código identifique que no se ha resuelto el problema, 
    Public Overrides Function ExecuteTarea(ByRef paramObjUnMensaje As MensajeVo) As RespuestaVo

        Dim texto As String
        Using sw As New System.IO.StringWriter
            sw.WriteLine("---")
            sw.WriteLine("Alerta desde el nodo centinela")
            sw.WriteLine("Se ha recibido la clave (key) [{0}]", paramObjUnMensaje.Key)
            sw.WriteLine("Que no ha sido interceptada por ningún nodo eslabón")
            sw.WriteLine("/Eof")
            sw.Flush()
            texto = sw.ToString
        End Using

        Throw New ArgumentOutOfRangeException("Key", paramObjUnMensaje.Key, texto)

    End Function
#End Region

End Class
